Package: release.debian.org
Severity: normal
Tags: bookworm
User: release.debian....@packages.debian.org
Usertags: pu
X-Debbugs-Cc: grml-rescueb...@packages.debian.org, t...@grml.org
Control: affects -1 + src:grml-rescueboot

[ Reason ]
grml-rescueboot can download Grml ISOs from the Internet.

The recent Grml 2024.12 release has a) changed the architectures
supported from i386,amd64 to amd64,arm64 and b) changed the names
of the ISOs.

grml-rescueboot, as a result, broke, as reported in #1091702.

[ Impact ]

This updates the regexes used to find the current release version, and
drops support for selecting which architecture to download for, and
updates the architecture support to amd64,arm64 from i386,amd64. The
package itself is Arch: all so from the package side it doesn't change
anything.

There is a NEWS entry notifying users that there is no i386 support
anymore. Runniong update-grml-rescueboot on i386 will result in a
failure like this:

> ERROR: Unsupported architecture 'i686'.

[ Tests ]

mika@ did a manual test on amd64.

[ Risks ]

It's a normal-complexity shellscript. Worst case users need to continue
using the ISO they already have.

i386 support being dropped is an impact.

[ Checklist ]
  [x] *all* changes are documented in the d/changelog
  [x] I reviewed all changes and I approve them
  [x] attach debdiff against the package in (old)stable
  [x] the issue is verified as fixed in unstable

[ Changes ]

Again, this does:
- in update-grml-rescueboot change supported archs from i386,amd64 to
  amd64,arm64
- drops -a flag (used to select architecture "bit width", ie 32/64
  previously)
- updates the expected ISO names and regexes
- add NEWS entry about end of i386 support

[ Other info ]

Can't think of anything.
diff -Nru grml-rescueboot-0.5.2/debian/changelog 
grml-rescueboot-0.5.2+deb12u1/debian/changelog
--- grml-rescueboot-0.5.2/debian/changelog      2022-03-21 16:25:10.000000000 
+0100
+++ grml-rescueboot-0.5.2+deb12u1/debian/changelog      2025-01-02 
18:37:31.000000000 +0100
@@ -1,3 +1,13 @@
+grml-rescueboot (0.5.2+deb12u1) bookworm; urgency=medium
+
+  * update-grml-rescueboot: remove -a (bitwidth) flag
+  * update-grml-rescueboot: support new ISO names and archs (Closes: #1091702)
+  * update-grml-rescueboot: rename isotype to grmlflavor
+  * update-grml-rescueboot: use grmlflavor in version regex
+  * Add NEWS entry about i386
+
+ -- Chris Hofstaedtler <c...@grml.org>  Thu, 02 Jan 2025 18:37:31 +0100
+
 grml-rescueboot (0.5.2) unstable; urgency=medium
 
   [ Allan Laal ]
diff -Nru grml-rescueboot-0.5.2/debian/NEWS 
grml-rescueboot-0.5.2+deb12u1/debian/NEWS
--- grml-rescueboot-0.5.2/debian/NEWS   1970-01-01 01:00:00.000000000 +0100
+++ grml-rescueboot-0.5.2+deb12u1/debian/NEWS   2025-01-02 18:37:31.000000000 
+0100
@@ -0,0 +1,12 @@
+grml-rescueboot (0.5.2+deb12u1) bookworm; urgency=medium
+
+  The end of i386
+  ---------------
+
+  As announced on [1] Grml no longer provides i386 PC ("32bit x86")
+  releases. For this reason, update-grml-rescueboot can also no longer
+  download a current Grml release for i386.
+
+  [1] https://blog.grml.org/archives/416-grml32-sunset.html
+
+ -- Chris Hofstaedtler <c...@grml.org>  Thu, 02 Jan 2025 15:24:00 +0100
diff -Nru grml-rescueboot-0.5.2/update-grml-rescueboot 
grml-rescueboot-0.5.2+deb12u1/update-grml-rescueboot
--- grml-rescueboot-0.5.2/update-grml-rescueboot        2021-12-22 
07:14:01.000000000 +0100
+++ grml-rescueboot-0.5.2+deb12u1/update-grml-rescueboot        2025-01-02 
18:37:27.000000000 +0100
@@ -6,8 +6,7 @@
 set -eu -o pipefail
 
 # defaults
-isotype=full
-bitwidth=auto
+grmlflavor=full
 force=0
 retrieved_iso=0
 
@@ -31,22 +30,14 @@
 fi
 
 usage() {
-  echo "Usage: $(basename "$0") [-f] [-a <32|64|96>] [-t <small|full>]"
+  echo "Usage: $(basename "$0") [-f] [-t <small|full>]"
 }
 
 while getopts ":a:t:fh" opt ; do
   case ${opt} in
-    a)
-      if [ "${OPTARG}" = 32 ] || [ "${OPTARG}" = 64 ] || [ "${OPTARG}" = 96 ] 
; then
-       bitwidth="$OPTARG"
-      else
-       echo "ERROR: Invalid value '${OPTARG}'. Supported values: 32, 64, 96" 
>&2
-       usage >&2 ; exit 1
-      fi
-      ;;
     t)
       if [ "${OPTARG}" = "full" ] || [ "${OPTARG}" = "small" ] ; then
-       isotype="${OPTARG}"
+       grmlflavor="${OPTARG}"
       else
        echo "ERROR: Invalid value '${OPTARG}'. Supported values: small, full" 
>&2
        usage >&2 ; exit 1
@@ -68,25 +59,23 @@
   esac
 done
 
-if [ "${bitwidth}" = auto ] ; then
-  arch="$(uname -m)"
-  case ${arch} in
-    i?86)
-      bitwidth=32
-      ;;
-    x86_64)
-      bitwidth=64
-      ;;
-    *)
-      echo "ERROR: Unknown architecture '${arch}', please specify -a flag." >&2
-      usage >&2
-      exit 1
-      ;;
-  esac
-fi
+arch="$(uname -m)"
+case ${arch} in
+  aarch64)
+    grmlarch=arm64
+    ;;
+  x86_64)
+    grmlarch=amd64
+    ;;
+  *)
+    echo "ERROR: Unsupported architecture '${arch}'." >&2
+    usage >&2
+    exit 1
+    ;;
+esac
 
 echo "Finding out latest ISO image..."
-date=$(wget --quiet -O- http://download.grml.org/ | sed --regex -n 
's/.*grml[0-9]{2}-(full|small)_([0-9]{4}\.[0-9]{2})\.iso.*/\2/p' | sort | tail 
-1)
+date=$(wget --quiet -O- http://download.grml.org/ | sed --regex -n 
's/.*grml-('"$grmlflavor"')-([0-9]{4}\.[0-9]{2})-('"$grmlarch"')\.iso.*/\2/p' | 
sort | tail -1)
 
 if [ -z "${date}" ] ; then
   echo "ERROR: Could not find out latest ISO." >&2
@@ -102,7 +91,7 @@
   exit 1
 fi
 
-if [ "${isotype}" = "full" ] && [ "${diskfree}" -lt 1048576 ] ; then
+if [ "${grmlflavor}" = "full" ] && [ "${diskfree}" -lt 1048576 ] ; then
   if [ "${force}" = "1" ] ; then
     echo "WARN: There might not be enough free disk space in /boot, continuing 
anyway as requested via -f."
   else
@@ -110,7 +99,7 @@
     echo "Note: >=1GB for grml-full recommended (use -f to force download 
anyway)."
     exit 1
   fi
-elif [ "${isotype}" = "small" ] && [ "${diskfree}" -lt 524288 ] ; then
+elif [ "${grmlflavor}" = "small" ] && [ "${diskfree}" -lt 524288 ] ; then
   if [ "${force}" = "1" ] ; then
     echo "WARN: There might not be enough free disk space in /boot, continuing 
anyway as requested via -f."
   else
@@ -120,7 +109,7 @@
   fi
 fi
 
-isoname="grml${bitwidth}-${isotype}_${date}.iso"
+isoname="grml-${grmlflavor}-${date}-${grmlarch}.iso"
 
 if [ "${force}" = "1" ] || ! [ -f "${output_directory}/${isoname}" ] ; then
   echo "Downloading Grml ISO to '${output_directory}/${isoname}'."

Reply via email to